/// <reference types="node" />
import type { IncomingMessage, ServerResponse } from 'http';
import type { LoadComponentsReturnType } from './load-components';
import type { ServerRuntime } from './config-shared';
import React from 'react';
import { NextParsedUrlQuery } from './request-meta';
import RenderResult from './render-result';
export declare type RenderOptsPartial = {
    err?: Error | null;
    dev?: boolean;
    serverComponentManifest?: any;
    supportsDynamicHTML?: boolean;
    runtime?: ServerRuntime;
    serverComponents?: boolean;
};
export declare type RenderOpts = LoadComponentsReturnType & RenderOptsPartial;
export declare type FlightRouterState = [
    segment: string,
    parallelRoutes: {
        [parallelRouterKey: string]: FlightRouterState;
    },
    url?: string,
    refresh?: 'refetch'
];
export declare type FlightSegmentPath = any[] | [
    segment: string,
    parallelRouterKey: string,
    segment: string,
    parallelRouterKey: string,
    segment: string,
    parallelRouterKey: string
];
export declare type FlightDataPath = any[] | [
    segment: string,
    parallelRoute: string,
    segment: string,
    parallelRoute: string,
    segment: string,
    parallelRoute: string,
    tree: FlightRouterState,
    subTreeData: React.ReactNode
];
export declare type FlightData = Array<FlightDataPath> | string;
export declare type ChildProp = {
    current: React.ReactNode;
    segment: string;
};
export declare function renderToHTML(req: IncomingMessage, res: ServerResponse, pathname: string, query: NextParsedUrlQuery, renderOpts: RenderOpts, isPagesDir: boolean): Promise<RenderResult | null>;
